// Copyright Paul John Floyd 2004, 2006
#include "ODHValidator.h"

#include <assert.h>

QValidator::State ODHValidator::validate(QString& input, int& /*pos*/) const
{
    if (input.length() == 0)
    {
        return QValidator::Intermediate;
    }
    unsigned int value;
    int base;
    bool ok;
    switch (mMode)
    {
    case DECIMAL:
        base = 10;
        break;
    case OCTAL:
        base = 8;
        break;
    case HEXADECIMAL:
        base = 16;
        break;
    default:
        assert(0);
        break;
    } // end switch

    value = input.toUInt(&ok, base);

    if (!ok)
    {
        return QValidator::Invalid;
    }
    else if (value >= mMinimum && value <= mMaximum)
    {
        return QValidator::Intermediate;
    }
    else
    {
        return QValidator::Acceptable;
    }
}
