
#if !defined(ODHVALIDATOR_H)
#define ODHVALIDATOR_H

// Copyright Paul John Floyd 2004

#if !defined(QVALIDATOR_H)
#include <qvalidator.h>
#endif // QVALIDATOR_H

class ODHValidator : public QValidator
{
public:
    ODHValidator(unsigned int minimum,
                 unsigned int maximum,
                 QObject* parent,
                 const char */*name*/) :
        QValidator(parent),
        mMode(DECIMAL),
        mMinimum(minimum),
        mMaximum(maximum)
    {}

    enum tMode { OCTAL, DECIMAL, HEXADECIMAL };

    void setMode(tMode mode) { mMode = mode; }

    virtual QValidator::State validate(QString& input, int& pos) const;
private:
    tMode mMode;
    unsigned int mMinimum, mMaximum;
};

#endif // ODHVALIDATOR_H
