#if !defined(DIAGNOSIS_WIZARD_H)
#define DIAGNOSIS_WIZARD_H

#include "ui_diagnosis_wizard4.h"
#include "Q3Wizard"
#include "pt.h"
#include <vector>

class DiagnosisWizard : public Q3Wizard, public Ui::DiagnosisWizard
{
    Q_OBJECT
public:
    DiagnosisWizard(QWidget *parent = 0);

public slots:
    void setData(std::vector<PartitionTable> *pts, std::vector<QString> *devs);
private slots: 
  void pageChange(const QString &page);
  void setCHS();
  void repairOrder();
private:
   void checkOverlap();
   void checkDuplicates();
   void checkGaps();
   void fillOrder();
   void checkCHS();
   void checkOrSetCHS(bool check);
 
 std::vector<PartitionTable> *mPartitionTables;
 std::vector<QString> *mDeviceArray;
};

#endif // DIAGNOSIS_WIZARD_H
