// Copyright Paul John Floyd 2004 - 2005

#include "ptentry.h"
#include <iostream>
using std::cout;
using std::endl;
using std::memset;

void extractCylinderSector(PTEntry& pt)
{
    CylinderSector cs;

    // sector in low 6 bits of low byte
    cs.extractedData.sector = pt.cylinderSectorStart.rawData[0] & 0x3F;

    // cylinder in upper byte + 2 high bits of low byte
    cs.extractedData.cylinder = pt.cylinderSectorStart.rawData[1] + ((pt.cylinderSectorStart.rawData[0] & 0xC0) << 2);
    pt.cylinderSectorStart.extractedData.cylinder = cs.extractedData.cylinder;
    pt.cylinderSectorStart.extractedData.sector = cs.extractedData.sector;
    
    cs.extractedData.sector = pt.cylinderSectorEnd.rawData[0] & 0x3F;
    cs.extractedData.cylinder = pt.cylinderSectorEnd.rawData[1] + ((pt.cylinderSectorEnd.rawData[0] & 0xC0) << 2);
    pt.cylinderSectorEnd.extractedData.cylinder = cs.extractedData.cylinder;
    pt.cylinderSectorEnd.extractedData.sector = cs.extractedData.sector;
}

void restoreCylinderSector(PTEntry& pt)
{
    CylinderSector cs;
    ::memset(&cs, 0, sizeof(CylinderSector));

    // put low 6 bits straight into low byte
    cs.rawData[0] = pt.cylinderSectorStart.extractedData.sector;

    // mask off lower byte of cylinder, shift down top two bits and
    // put into top of low byte
    cs.rawData[0] |= (pt.cylinderSectorStart.extractedData.cylinder & 0x300) >> 2;
    // low 8 bits of cyliner in top byte
    cs.rawData[1] = pt.cylinderSectorStart.extractedData.cylinder & 0xFF;

    // end
    pt.cylinderSectorStart.rawData[0] = cs.rawData[0];
    pt.cylinderSectorStart.rawData[1] = cs.rawData[1];

    cs.rawData[0] = pt.cylinderSectorEnd.extractedData.sector;
    cs.rawData[0] |= (pt.cylinderSectorEnd.extractedData.cylinder & 0x300) >> 2;
    cs.rawData[1] = pt.cylinderSectorEnd.extractedData.cylinder & 0xFF;
    pt.cylinderSectorEnd.rawData[0] = cs.rawData[0];
    pt.cylinderSectorEnd.rawData[1] = cs.rawData[1];
}

/*
bool CHSMatchesLBA(const PartitionTable& pt)
{
    unsigned long CHSStart, CHSEnd;
    for (int i = 0; i < 4; ++i)
    {
        CHSStart = 0;
    }
    return true;
}
*/
