#if !defined(PFDISK_H)
#define PFDISK_H

#include "ui_pfdisk4.h"
#include "ODHValidator.h"
#include "diagnosis_wizard.h"

class pfdisk : public QDialog, public Ui::pfdisk
{
   Q_OBJECT
public:
   pfdisk(QWidget *parent = 0);
   ~pfdisk();

private slots:
   void actionSave();
   void changeBase(int index);
   void actionDiagnosis();
   void refresh(int index);
   void actionAbout();
   void actionTypeChanged(QString newString);
 private:

   int readDirectory(const QString& diskPath, QString& value);
   int getAlias(const QString& alias);
   void makeBackup();
   void readCurrentDisk();
   int inquiry(int fd,  scsi_inquiry& inq_data, int inq_len);

   std::vector<QString> mDeviceArray;
   std::vector<PartitionTable> mPartitionTables;
   int mBase;
   int mCurrentDisk;
   bool mInitDone;

   QLineEdit* mStateLineEdit[4];
   QLineEdit* mTypeLineEdit[4];
   
   QLineEdit* mCylinderStartLineEdit[4];
   QLineEdit* mCylinderEndLineEdit[4];
   QLineEdit* mHeadStartLineEdit[4];
   QLineEdit* mHeadEndLineEdit[4];
   QLineEdit* mSectorStartLineEdit[4];
   QLineEdit* mSectorEndLineEdit[4];
   QLineEdit* mLBAStartLineEdit[4];
   QLineEdit* mLBALengthLineEdit[4];
   
   ODHValidator* mValidator6;
   ODHValidator* mValidator8;
   ODHValidator* mValidator8m1;
   ODHValidator* mValidator10;
   ODHValidator* mValidator32;
};

#endif // PFDISK_H
